﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DiplomovaPrace
{
    public partial class DialogCinnost : Form
    {
        Graf graf;
        Hrana hrana;
        SeznamHran hrany;

        public Hrana Hrana
        {
            get { return hrana; }
            set { hrana = value; }
        }

        public DialogCinnost(Graf graf, SeznamHran hrany)
        {
            InitializeComponent();
            this.graf = graf;
            this.hrany = hrany;
            /*hrany.Clear();
            foreach (Hrana polozka in graf.naslednici)
            {
                Vrchol pomVrchol = new Vrchol(polozka.Vrchol1.GetKlic()); //pocatecni vrchol hrany
                pomVrchol = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(pomVrchol, 0)]);
                if (pomVrchol.PocetPredchudcu > 0)
                {
                    polozka.Data.PoleHran = new ADTHrana[pomVrchol.PocetPredchudcu];
                    for (int i = pomVrchol.IndexPrvnihoPredchudce; i < pomVrchol.PocetPredchudcu + pomVrchol.IndexPrvnihoPredchudce; i++)
                    {
                        Hrana pomHrana = ((Hrana)(graf.predchudci[i]));
                        ADTHrana predHrana = new ADTHrana(pomHrana.Vrchol1.GetKlic(), pomHrana.Vrchol2.GetKlic());
                        polozka.Data.PoleHran[i - pomVrchol.IndexPrvnihoPredchudce] = predHrana;
                    }
                }
                hrany.Add(polozka);
            }*/
        }
        private void VypisZdrojuHrany()
        {
            zdrojeListView.BeginUpdate();
            try
            {
                zdrojeListView.Items.Clear();
                foreach (ZdrojHrany polozka in Hrana.Data.zdrojeHrany)
                {
                    ListViewItem item = new ListViewItem(polozka.Nazev);
                    item.SubItems.Add(polozka.Spotreba.ToString());
                    zdrojeListView.Items.Add(item);
                }
            }
            finally
            {
                zdrojeListView.EndUpdate();
            }
        }

        private void UpdatePredchudciComboBox()
        {
            predchudciComboBox.Items.Clear();
            foreach (Hrana polozka in graf.naslednici)
            {
                predchudciComboBox.Items.Add(polozka.Data.Nazev);
            }
        }

        private void VypisSeznamPredchudcu()
        {
            string retezec;
            Vrchol vrchol = new Vrchol(hrana.Vrchol1.GetKlic());
            vrchol = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(vrchol, 0)]);
            predchudciListView.BeginUpdate();
            predchudciListView.Items.Clear();
            if (hrana.Data.poleHran!=null)
            foreach (ADTHrana polozka in hrana.Data.PoleHran)
            {
                Hrana hledanaHrana = new Hrana(polozka.Vrchol1, polozka.Vrchol2);
                Hrana pomHrana =((Hrana)(graf.naslednici[graf.naslednici.Najdi(hledanaHrana,0)]));
                retezec = pomHrana.Data.Nazev;
                ListViewItem item = new ListViewItem(retezec);
                item.SubItems.Add(pomHrana.Vrchol1.GetKlic());
                item.SubItems.Add(pomHrana.Vrchol2.GetKlic());
                predchudciListView.Items.Add(item);
            }
            predchudciListView.EndUpdate();
        }
        private void DialogCinnost_Load(object sender, EventArgs e)
        {
            if (graf.TypOhodnoceniHran == "CPM")
            {
                label1.Visible = false;
                label4.Visible = false;
                label7.Visible = false;
                optimistickyTextBox.Visible = false;
                modusTextBox.Visible = false;
                pesimistickyTextBox.Visible = false;
            }
            else
            {
                ohodnoceniTextBox.Visible = false;
            }
            UpdatePredchudciComboBox();
            foreach (Zdroj polozka in graf.zdroje)
            {
                 zdrojComboBox.Items.Add(polozka.Nazev);
            }
            nazevTextBox.Text = hrana.Data.Nazev;
            if (string.IsNullOrEmpty(hrana.Vrchol1.GetKlic()))
            {
                ohodnoceniTextBox.Text = "0";
                optimistickyTextBox.Text = "0";
                modusTextBox.Text = "0";
                pesimistickyTextBox.Text = "0";
            }
            else
            {
                ohodnoceniTextBox.Text = hrana.Data.Ohodnoceni.ToString();
                optimistickyTextBox.Text = hrana.Data.A.ToString();
                modusTextBox.Text = hrana.Data.M.ToString();
                pesimistickyTextBox.Text = hrana.Data.B.ToString();
                zkratkaTextBox.Text = hrana.Data.Zkratka;
                informaceRichTextBox.Text = hrana.Data.Info;
                VypisZdrojuHrany();
            }
            VypisSeznamPredchudcu();
        }

        private void zdrojComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (zdrojComboBox.SelectedItem == null) return;
            if (string.IsNullOrEmpty(zdrojComboBox.SelectedItem.ToString())) return;
            infoZdrojListBox.Items.Clear();
            infoZdrojListBox.BeginUpdate();
            Zdroj pomZdroj = new Zdroj();
            pomZdroj.Nazev = zdrojComboBox.SelectedItem.ToString();
            int pozice = graf.zdroje.Najdi(pomZdroj, 0);
            infoZdrojListBox.Items.Add("Zdroj: " + ((Zdroj)(graf.zdroje[pozice])).Nazev);
            infoZdrojListBox.Items.Add("Aktuální kapacita: " + ((Zdroj)(graf.zdroje[pozice])).AktualniKapacita.ToString());
            infoZdrojListBox.Items.Add("Původní kapacita: " + ((Zdroj)(graf.zdroje[pozice])).PuvodniKapacita.ToString());
            if (((Zdroj)(graf.zdroje[pozice])).Obnovitelnost == true) infoZdrojListBox.Items.Add("Obnovitelný");
            else infoZdrojListBox.Items.Add("Neobnovitelný");
            infoZdrojListBox.EndUpdate();
        }

        private void pridatButton_Click(object sender, EventArgs e)
        {
            if (zdrojComboBox.SelectedItem == null) return;
            if (string.IsNullOrEmpty(zdrojComboBox.SelectedItem.ToString())) return;
            ZdrojHrany pomZdroj = new ZdrojHrany();
            pomZdroj.Nazev = zdrojComboBox.SelectedItem.ToString();
            double spotrebaHrany = 0;
            if (!double.TryParse(spotrebaTextBox.Text, out spotrebaHrany))
            {
                MessageBox.Show("Není vyplněna korekektně spotřeba zdroje.", "Chyba v zadávání", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            pomZdroj.Spotreba = spotrebaHrany;
            if (hrana.PridejZdroj(pomZdroj) == 1)
                MessageBox.Show("Hrana tento zdroj již využívá. Změnte jeho spotřebu.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
            VypisZdrojuHrany();
        }

        private void pridatPredchudceButton_Click(object sender, EventArgs e)
        {
            int index = predchudciComboBox.SelectedIndex;
            if (index < 0) return;
            Hrana pomHrana = (Hrana)(graf.naslednici[index]);
            if (graf.naslednici.Najdi(pomHrana, 0) < 0)
            {
                MessageBox.Show("Chyba. Činnost nenalezena.");
                return;
            }
            if (hrana.Data.poleHran == null) hrana.Data.poleHran = new ADTHrana[0];
            Array.Resize(ref hrana.Data.poleHran, hrana.Data.PoleHran.Length + 1);
            ADTHrana predHrana = new ADTHrana(pomHrana.Vrchol1.GetKlic(), pomHrana.Vrchol2.GetKlic());
            hrana.Data.PoleHran[hrana.Data.PoleHran.Length-1] = predHrana;
            VypisSeznamPredchudcu();
            //MessageBox.Show(pomHrana.Vrchol1.GetKlic() + pomHrana.Vrchol2.GetKlic());
            /*Vrchol pomVrchol1 = new Vrchol(pomHrana.Vrchol2.GetKlic()); //koncovy vrchol hrany, ktera ma predchazet
            pomVrchol1 = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(pomVrchol1, 0)]);
            Vrchol vrchol = new Vrchol(hrana.Vrchol1.GetKlic());
            vrchol = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(vrchol, 0)]); //pocatecni vrchol aktualni hrany - ten musim presunout
            graf.OdeberHranu(hrana);
            hrana.Vrchol1.SetKlic(pomHrana.Vrchol2.GetKlic());
            graf.VlozHranu(hrana);
            SeznamHran seznamPredchudcu = new SeznamHran();
            for (int i = vrchol.IndexPrvnihoPredchudce; i < vrchol.PocetPredchudcu + vrchol.IndexPrvnihoPredchudce; i++)
            {
                Hrana pomHrana2 = ((Hrana)(graf.predchudci[i]));
                seznamPredchudcu.Add(pomHrana2);
            }
            foreach (Hrana polozka in seznamPredchudcu)
            {
                Vrchol vrchol2 = new Vrchol(polozka.Vrchol1.GetKlic());
                vrchol2 = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(vrchol2, 0)]);
                graf.OdeberHranu(polozka);
                polozka.Vrchol2.SetKlic(hrana.Vrchol1.GetKlic());
                graf.VlozHranu(polozka);
            }
            seznamPredchudcu.Clear();
            for (int i = vrchol.IndexPrvnihoNaslednika; i < vrchol.PocetNasledniku + vrchol.IndexPrvnihoNaslednika; i++)
            {
                Hrana pomHrana2 = ((Hrana)(graf.naslednici[i]));
                seznamPredchudcu.Add(pomHrana2);
            }
            foreach (Hrana polozka in seznamPredchudcu)
            {
                Vrchol vrchol2 = new Vrchol(polozka.Vrchol2.GetKlic());
                vrchol2 = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(vrchol2, 0)]);
                graf.OdeberHranu(polozka);
                polozka.Vrchol1.SetKlic(hrana.Vrchol1.GetKlic());
                graf.VlozHranu(polozka);
            }
            if (vrchol.PocetNasledniku > 0 || vrchol.PocetPredchudcu > 0) MessageBox.Show("Chyba při přetváření");
            pomVrchol1.SouradniceX = vrchol.SouradniceX;
            pomVrchol1.SouradniceY = vrchol.SouradniceY;
            graf.OdeberVrchol(vrchol);   */
        }

        private void DialogCinnost_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (DialogResult == DialogResult.Cancel) return;
            e.Cancel = true;
            if (string.IsNullOrEmpty(nazevTextBox.Text))
            {
                MessageBox.Show("Název činnosti není vyplněn.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (string.IsNullOrEmpty(zkratkaTextBox.Text))
            {
                MessageBox.Show("Zkratka činnosti není vyplněn.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            double pomOhodnoceni;
            if (!double.TryParse(ohodnoceniTextBox.Text, out pomOhodnoceni))
            {
                MessageBox.Show("Není vyplněno korektně ohodnocení hrany", "Chyba v zadávání", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (!double.TryParse(optimistickyTextBox.Text, out pomOhodnoceni))
            {
                MessageBox.Show("Není vyplněn korektně optimisticky odhad", "Chyba v zadávání", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (!double.TryParse(modusTextBox.Text, out pomOhodnoceni))
            {
                MessageBox.Show("Není vyplněn korektně nejpravděpodobnější odhad", "Chyba v zadávání", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (!double.TryParse(pesimistickyTextBox.Text, out pomOhodnoceni))
            {
                MessageBox.Show("Není vyplněn korektně pesimistický odhad", "Chyba v zadávání", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            e.Cancel = false;
        }

        private void DialogCinnost_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (DialogResult == DialogResult.Cancel)
            {
                //Vrchol vrchol = new Vrchol(hrana.Vrchol1.GetKlic());
                //graf.OdeberVrchol(vrchol);
                //vrchol = new Vrchol(hrana.Vrchol2.GetKlic());
                //graf.OdeberVrchol(vrchol);
                return;
            }
            hrana.Data.Nazev = nazevTextBox.Text;
            hrana.Data.Info = informaceRichTextBox.Text;
            hrana.Data.Zkratka = zkratkaTextBox.Text;
            if (graf.TypOhodnoceniHran == "CPM")
            {
                hrana.Data.Ohodnoceni = double.Parse(ohodnoceniTextBox.Text);
            }
            else
            {
                hrana.Data.A = double.Parse(optimistickyTextBox.Text);
                hrana.Data.M = double.Parse(modusTextBox.Text);
                hrana.Data.B = double.Parse(pesimistickyTextBox.Text);
            }
        }

        private void OKDialogButton_Click(object sender, EventArgs e)
        {

        }

        private void odebratPredchudceButton_Click(object sender, EventArgs e)
        {
            
            if (predchudciListView.SelectedIndices.Count != 1)
            {
                MessageBox.Show("Není vybrána pouze jedna položka", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            string klic1 = predchudciListView.SelectedItems[0].SubItems[1].Text;
            string klic2 = predchudciListView.SelectedItems[0].SubItems[2].Text;
            if (hrana.Data.PoleHran.Length == 0)
            {
                return;
            }
            for (int i = 0; i < hrana.Data.poleHran.Length; i++)
            {
                if (hrana.Data.PoleHran[i].Vrchol1.GetKlic() == klic1 && hrana.Data.PoleHran[i].Vrchol2.GetKlic() == klic2)
                {
                    if (hrana.Data.PoleHran.Length == 1)
                    {
                        hrana.Data.PoleHran=null;
                        VypisSeznamPredchudcu();
                        return;
                    }
                    ADTHrana[] novePole = new ADTHrana[hrana.Data.PoleHran.Length-1];
                    for (int j = 0; j < i; j++)
                    {
                        ADTHrana novaHrana = new ADTHrana(hrana.Data.PoleHran[j].Vrchol1.GetKlic(),hrana.Data.PoleHran[j].Vrchol2.GetKlic());
                        novePole[j] = novaHrana;
                    }
                    for (int j = i; j < novePole.Length; j++)
                    {
                        ADTHrana novaHrana = new ADTHrana(hrana.Data.PoleHran[j+1].Vrchol1.GetKlic(),hrana.Data.PoleHran[j+1].Vrchol2.GetKlic());
                        novePole[j] = novaHrana;
                    }
                    hrana.Data.PoleHran = novePole; 
                }
            }
            VypisSeznamPredchudcu();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (zdrojeListView.SelectedIndices.Count != 1)
            {
                MessageBox.Show("Není vybrána pouze jedna položka", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            string klic = zdrojeListView.SelectedItems[0].SubItems[0].Text;
            ZdrojHrany pomZdroj = new ZdrojHrany();
            pomZdroj.Nazev=klic;
            int index = hrana.Data.zdrojeHrany.Najdi(pomZdroj, 0);
            if (index < 0)
            {
                MessageBox.Show("Zdroje nenalezen.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            hrana.Data.zdrojeHrany.RemoveAt(index);
            VypisZdrojuHrany();
        }
    }
}
