﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DiplomovaPrace
{
    public partial class DialogNapoveda : Form
    {
        private SortedArrayList hesla = new SortedArrayList();
        public DialogNapoveda()
        {
            InitializeComponent();
        }

        private void zavritButton_Click(object sender, EventArgs e)
        {
            Hide();
        }
        public void naplneniHesly()
        {
            hesla.Clear();
            try
            {
                using (StreamReader sr = new StreamReader(File.OpenRead("Nápověda\\hesla.txt")))
                {
                    String pomText = sr.ReadLine();
                    int pocet = int.Parse(pomText);
                    for (int i=0; i<pocet; i++)
                    {
                        String item = sr.ReadLine();
                        hesla.Add(item);
                    }
                }
            }
            catch (Exception) { }
            Vypis();
        }

        private void Vypis()
        {
            heslaListBox.BeginUpdate();
            heslaListBox.Items.Clear();
            foreach (String item in hesla)
            {
                heslaListBox.Items.Add(item);
            }
            heslaListBox.EndUpdate();
        }

        private void DialogNapoveda_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Hide();
        }

        private void ulozButton_Click(object sender, EventArgs e)
        {
            String nazevSouboru = "Nápověda\\" + hesloTextBox.Text;
            FileStream fs = new FileStream(nazevSouboru, FileMode.Create);
            BinaryWriter bw = new BinaryWriter(fs);
            bw.Write(napovedaRichTextBox.Text);            
            bw.Close();

            hesla.Insert(hesloTextBox.Text);
            try
            {
                fs = new FileStream("Nápověda\\hesla.txt", FileMode.Create);
                StreamWriter sw = new StreamWriter(fs);
                sw.WriteLine(hesla.Count);
                foreach (String item in hesla)
                {
                    sw.WriteLine(item);
                }
                sw.Close();
            }
            catch (Exception exception)
            {
                MessageBox.Show(exception.Message, "Chyba");
            }
            

        }

        private void heslaListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            String jmeno = "Nápověda\\" + heslaListBox.SelectedItem.ToString();
            hesloTextBox.Text = heslaListBox.SelectedItem.ToString();
            FileStream fs = new FileStream(jmeno, FileMode.Open);
            try
            {
                using (BinaryReader br = new BinaryReader(fs))
                {
                    do
                    {
                        String i = br.ReadString();
                        napovedaRichTextBox.Text = i;
                    } while (true);
                }
            }
            catch (EndOfStreamException) { } // OK
        }
    }
}
