﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DiplomovaPrace
{
    public partial class DialogTabulkovaEditace : Form
    {
        Graf graf;
        String typEditace;

        public String TypEditace
        {
            get { return typEditace; }
            set { typEditace = value; }
        }
        SeznamHran cinnosti = new SeznamHran();
        public DialogTabulkovaEditace(Graf graf)
        {
            InitializeComponent();
            this.graf = graf;
            cinnosti.Clear();
            foreach (Hrana polozka in graf.naslednici)
            {
                Vrchol pomVrchol = new Vrchol(polozka.Vrchol1.GetKlic()); //pocatecni vrchol hrany
                pomVrchol = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(pomVrchol, 0)]);
                if (pomVrchol.PocetPredchudcu > 0)
                {
                    polozka.Data.PoleHran = new ADTHrana[pomVrchol.PocetPredchudcu];
                    for (int i = pomVrchol.IndexPrvnihoPredchudce; i < pomVrchol.PocetPredchudcu + pomVrchol.IndexPrvnihoPredchudce; i++)
                    {
                        Hrana pomHrana = ((Hrana)(graf.predchudci[i]));
                        ADTHrana predHrana = new ADTHrana(pomHrana.Vrchol1.GetKlic(), pomHrana.Vrchol2.GetKlic());
                        polozka.Data.PoleHran[i - pomVrchol.IndexPrvnihoPredchudce] = predHrana;
                    }
                }
                cinnosti.Add(polozka);
            }
            VytvorGraf();
            cinnosti.Clear();
            foreach (Hrana polozka in graf.naslednici)
            {
                Vrchol pomVrchol = new Vrchol(polozka.Vrchol1.GetKlic()); //pocatecni vrchol hrany
                pomVrchol = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(pomVrchol, 0)]);
                if (pomVrchol.PocetPredchudcu > 0)
                {
                    polozka.Data.PoleHran = new ADTHrana[pomVrchol.PocetPredchudcu];
                    for (int i = pomVrchol.IndexPrvnihoPredchudce; i < pomVrchol.PocetPredchudcu + pomVrchol.IndexPrvnihoPredchudce; i++)
                    {
                        Hrana pomHrana = ((Hrana)(graf.predchudci[i]));
                        ADTHrana predHrana = new ADTHrana(pomHrana.Vrchol1.GetKlic(), pomHrana.Vrchol2.GetKlic());
                        polozka.Data.PoleHran[i - pomVrchol.IndexPrvnihoPredchudce] = predHrana;
                    }
                }
                cinnosti.Add(polozka);
            }

        }

        private void Vypis()
        {
            String retezec;
            String nazevRetezec;
            try
            {
                cinnostiListView.BeginUpdate();
                cinnostiListView.Items.Clear();
                foreach (Hrana polozka in cinnosti)
                {
                    ListViewItem item = new ListViewItem(polozka.Vrchol1.GetKlic());
                    item.SubItems.Add(polozka.Vrchol2.GetKlic());
                    item.SubItems.Add(polozka.Data.Zkratka);
                    item.SubItems.Add(polozka.Data.Nazev);
                    if (typEditace == "PERT")
                    {
                        item.SubItems.Add(polozka.Data.A.ToString() + "-" + polozka.Data.M.ToString() + "-" + polozka.Data.B.ToString());
                    }
                    else
                        item.SubItems.Add(polozka.Data.Ohodnoceni.ToString());
                    retezec = "";
                    foreach (ZdrojHrany polozkaZdroj in polozka.Data.zdrojeHrany)
                    {
                        retezec += polozkaZdroj.Nazev + "(" + polozkaZdroj.Spotreba.ToString() + ")" + ",";
                    }
                    if (retezec.Length > 0) retezec = retezec.Remove(retezec.Length - 1);
                    if (retezec == "") retezec = "-";
                    item.SubItems.Add(retezec);
                    retezec = "";
                    Vrchol vrchol = new Vrchol(polozka.Vrchol1.GetKlic());
                    vrchol = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(vrchol, 0)]);
                    int index = 0;
                    if (polozka.Data.poleHran != null)
                        for (int i = 0; i < polozka.Data.PoleHran.Length; i++)
                        {
                            Hrana pomPredHrana = new Hrana(polozka.Data.PoleHran[i].Vrchol1, polozka.Data.poleHran[i].Vrchol2);
                            index =graf.naslednici.Najdi(pomPredHrana, 0);
                            if (index >= 0)
                            {
                                pomPredHrana = (Hrana)(graf.naslednici[index]);
                                nazevRetezec = pomPredHrana.Data.Zkratka + ",";
                                retezec += nazevRetezec;
                            }
                            //if (i != vrchol.PocetPredchudcu + vrchol.IndexPrvnihoPredchudce - 1) retezec += ",";
                        }
                    if (retezec.Length>0) retezec = retezec.Remove(retezec.Length - 1);
                    item.SubItems.Add(retezec);
                    cinnostiListView.Items.Add(item);
                }
                /*foreach (Hrana polozka in graf.naslednici)
                {
                    ListViewItem item = new ListViewItem(polozka.Vrchol1.GetKlic());
                    item.SubItems.Add(polozka.Vrchol2.GetKlic());
                    item.SubItems.Add(polozka.Data.Nazev);
                    item.SubItems.Add(polozka.Data.Ohodnoceni.ToString());
                    retezec = "";
                    foreach (ZdrojHrany polozkaZdroj in polozka.Data.zdrojeHrany)
                    {
                        retezec += polozkaZdroj.Nazev + "(" + polozkaZdroj.Spotreba.ToString() + ")";
                    }
                    if (retezec == "") retezec = "-";
                    item.SubItems.Add(retezec);
                    retezec = "";
                    Vrchol vrchol = new Vrchol(polozka.Vrchol1.GetKlic());
                    vrchol = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(vrchol, 0)]);
                    for (int i = vrchol.IndexPrvnihoPredchudce; i < vrchol.PocetPredchudcu + vrchol.IndexPrvnihoPredchudce; i++)
                    {
                        nazevRetezec = ((Hrana)(graf.predchudci[i])).Data.Nazev;
                        retezec += nazevRetezec;
                        if (i != vrchol.PocetPredchudcu + vrchol.IndexPrvnihoPredchudce-1) retezec += ",";
                        if (retezec.Length > (int)(this.zdrojeColumnHeader.Width / cinnostiListView.Font.Size))
                        {
                            retezec += "\n";
                        }
                    }
                    item.SubItems.Add(retezec);
                    cinnostiListView.Items.Add(item);
                }*/
            }
            finally
            {
                cinnostiListView.EndUpdate();
            }
        }

        private void DialogTabulkovaEditace_Load(object sender, EventArgs e)
        {
            Vypis();
        }

        private void cinnostiListView_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void cinnostiListView_DoubleClick(object sender, EventArgs e)
        {
            if (cinnostiListView.SelectedIndices.Count != 1)
            {
                MessageBox.Show("Není vybrána pouze jedna položka", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            using (DialogCinnost dialog = new DialogCinnost(graf, cinnosti))
            {
                Hrana hrana = new Hrana();
                hrana.Vrchol1.SetKlic(cinnostiListView.SelectedItems[0].SubItems[0].Text);
                hrana.Vrchol2.SetKlic(cinnostiListView.SelectedItems[0].SubItems[1].Text);
                int pom = graf.naslednici.Najdi(hrana, 0);
                if (pom <= -1)
                {
                    MessageBox.Show("Hrana nenalezena", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                dialog.Hrana = (Hrana)graf.naslednici[pom];
                if (dialog.ShowDialog() == DialogResult.OK)
                {
                    //vypisHranListView.SelectedItems[0].SubItems[0].Text = dialog.Hrana.Vrchol1.GetKlic();
                    //vypisHranListView.SelectedItems[0].SubItems[1].Text = dialog.Hrana.Vrchol2.GetKlic();
                    //vypisHranListView.SelectedItems[0].SubItems[2].Text = dialog.Hrana.Data.Nazev;
                    //vypisHranListView.SelectedItems[0].SubItems[3].Text = dialog.Hrana.Data.Ohodnoceni.ToString();
                }
            }
            Vypis();
        }

        private int UrciSouradnice()
        {
            if (graf.vrcholy.Count == 0) return -1;
            foreach (Hrana polozka in graf.naslednici)
            {
                polozka.Data.DocasneOhodnoceni = polozka.Data.Ohodnoceni;
                polozka.Data.Ohodnoceni = 1;
            }

            Vrchol pocatek=null;
            foreach (Vrchol polozka in graf.vrcholy)
            {
                if (polozka.PocetPredchudcu == 0) pocatek = polozka;
            }
            pocatek.SouradniceX = 70;
            pocatek.SouradniceY = 70;
            double hodnotaCPM = 0; ;
            int chybaReseni = 0;
            hodnotaCPM = graf.AlgoritmusTopologickehoUsporadani(true);
            chybaReseni = (int)hodnotaCPM;
            /*
            switch (chybaReseni)
            {
                case -1: MessageBox.Show("V síťovém grafu je více než jeden počátečních uzlů.", "Špatný vstup", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    break;
                case -2: MessageBox.Show("V síťovém grafu je více než jeden koncových uzlů.", "Špatný vstup", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    break;
                case -3: MessageBox.Show("V síťovém grafu není počáteční uzel.", "Špatný vstup", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    break;
                case -4: MessageBox.Show("V síťovém grafu není koncový uzel", "Špatný vstup", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    break;
                case -5: MessageBox.Show("Síťový graf není acyklický.", "Špatný vstup", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    break;
            }*/
            if (chybaReseni == -1)
            {
                VytvorGraf();
            }
            if (chybaReseni < 0) return -1;
            int vnoreni;
            int maximum = 0;
            foreach (Vrchol polozka in graf.vrcholy)
            {
                vnoreni = (int)(polozka.MinimalniCas);
                polozka.SouradniceX = 70 + 140 * vnoreni;
                if (vnoreni > maximum) maximum = vnoreni;

            }
            hodnotaCPM = graf.AlgoritmusTopologickehoUsporadaniMin(true);
            int[] poleVnoreni = new int[maximum + 2];
            foreach (Vrchol polozka in graf.vrcholy)
            {
                vnoreni = (int)(polozka.MaximalniCas);
                
                poleVnoreni[vnoreni] += 1;
                polozka.SouradniceY = 70 * poleVnoreni[vnoreni];
            }
            foreach (Hrana polozka in graf.naslednici)
            {
                polozka.Data.Ohodnoceni = polozka.Data.DocasneOhodnoceni;
            }
            graf.Prohlidka(graf.ZpristupniPocatecniUzel());
            bool zmenaSouradnic = true;

            while (zmenaSouradnic == true)
            {
                zmenaSouradnic = false;
                foreach (Vrchol polozka in graf.vrcholy)
                {
                    foreach (Vrchol item in graf.vrcholy)
                    {
                        if (polozka.SouradniceX == item.SouradniceX && polozka.SouradniceY == item.SouradniceY && item.Klic.GetKlic()!=polozka.Klic.GetKlic())
                        {
                            zmenaSouradnic = true;
                            polozka.SouradniceY += 70;
                        }
                    }
                }
            }
            return 0;
        }

        private void vytvoritCinnostButton_Click(object sender, EventArgs e)
        {
            using (DialogCinnost dialog = new DialogCinnost(graf, cinnosti))
            {
                Hrana hrana = new Hrana();
                Vrchol vrchol1 = new Vrchol();
                Vrchol vrchol2 = new Vrchol();
                String klic;
                int pom;
                int posledniKlic = 0;
                do
                {
                    klic = "V" + posledniKlic.ToString("D4");
                    vrchol1.Klic.SetKlic(klic);
                    vrchol1.Nazev = klic;
                    pom = graf.VlozVrchol(vrchol1);
                    posledniKlic++;
                } while (pom >= 1);
                do
                {
                    klic = "V" + posledniKlic.ToString("D4");
                    vrchol2.Klic.SetKlic(klic);
                    vrchol2.Nazev = klic;
                    pom = graf.VlozVrchol(vrchol2);
                    posledniKlic++;
                } while (pom >= 1);
                hrana.Vrchol1.SetKlic(vrchol1.Klic.GetKlic());
                hrana.Vrchol2.SetKlic(vrchol2.Klic.GetKlic());
                hrana.Data.Nazev = vrchol1.Klic.GetKlic() + vrchol2.Klic.GetKlic();
                hrana.Data.Zkratka = "H" + hrana.Data.Nazev[4].ToString() + hrana.Data.Nazev[9].ToString();
                graf.VlozHranu(hrana);
                cinnosti.Add(hrana);

                /*hrana.Vrchol1.SetKlic(cinnostiListView.SelectedItems[0].SubItems[0].Text);
                hrana.Vrchol2.SetKlic(cinnostiListView.SelectedItems[0].SubItems[1].Text);
                int pom = graf.naslednici.Najdi(hrana, 0);
                if (pom <= -1)
                {
                    MessageBox.Show("Hrana nenalezena", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }*/
                dialog.Hrana = hrana;
                if (dialog.ShowDialog() == DialogResult.OK)
                {
                    Vypis();
                }
            }
        }

        private void DialogTabulkovaEditace_FormClosed(object sender, FormClosedEventArgs e)
        {

        }

        private void editaceOKButton_Click(object sender, EventArgs e)
        {

        }

        private void DialogTabulkovaEditace_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (VytvorGraf() == 1)
            {
                e.Cancel = true;
                return;
            }
            UrciSouradnice();
        }

        private int VytvorGraf()
        {
            SeznamHran puvodniCinnosti = new SeznamHran();
            foreach (Hrana polozka in cinnosti)
            {
                puvodniCinnosti.Add(polozka);
            }
            graf.InitKeepZdroje();
            String klic;
            int pom;
            int posledniKlic = 1;
            SeznamHran vlozeneCinnosti = new SeznamHran();
            SeznamHran zpracovaneCinnosti = new SeznamHran();
            Vrchol vrchol1 = new Vrchol("V000");
            vrchol1.Nazev = "V000";
            graf.VlozVrchol(vrchol1);
            /*foreach (Hrana polozka in cinnosti)
            {
                Vrchol pomVrchol = new Vrchol(polozka.Vrchol1.GetKlic());
                pomVrchol.Nazev = pomVrchol.Klic.GetKlic();
                graf.VlozVrchol(pomVrchol);
                pomVrchol = new Vrchol(polozka.Vrchol2.GetKlic());
                pomVrchol.Nazev = pomVrchol.Klic.GetKlic();
                graf.VlozVrchol(pomVrchol);
                graf.VlozHranu(polozka);
            }*/

            foreach (Hrana polozka in cinnosti)
            {
                if (polozka.Data.PoleHran == null)
                {
                    Vrchol vrchol2 = new Vrchol();
                    do
                    {
                        klic = "V" + posledniKlic.ToString("D3");
                        vrchol2.Klic.SetKlic(klic);
                        vrchol2.Nazev = klic;
                        pom = graf.VlozVrchol(vrchol2);
                        posledniKlic++;
                    } while (pom >= 1);
                    Hrana hrana = new Hrana(vrchol1.Klic, vrchol2.Klic);
                    polozka.Kopie2(hrana);
                    hrana.Data.Zkratka = polozka.Data.Zkratka;
                    polozka.Data.PoleHran = null;
                    polozka.Data.PoleHran = new ADTHrana[1];
                    polozka.Data.PoleHran[0] = new ADTHrana(vrchol1.Klic.GetKlic(), vrchol2.Klic.GetKlic());
                    if (vlozeneCinnosti.Najdi(polozka, 0) >= 0)
                    {
                        vlozeneCinnosti.OdeberHranu(polozka);
                    }
                    vlozeneCinnosti.Add(polozka);
                    zpracovaneCinnosti.Add(polozka);
                    if (graf.naslednici.Najdi(hrana, 0) >= 0)
                    {
                        Vrchol fiktivniVrchol = new Vrchol();
                        //MessageBox.Show("1");
                        klic = "V" + posledniKlic.ToString("D3");
                        fiktivniVrchol.Klic.SetKlic(klic);
                        fiktivniVrchol.Nazev = klic;
                        pom = graf.VlozVrchol(fiktivniVrchol);
                        posledniKlic++;
                        Hrana fiktivniHrana = new Hrana();
                        fiktivniHrana.Vrchol1.SetKlic(fiktivniVrchol.Klic.GetKlic());
                        fiktivniHrana.Vrchol2.SetKlic(hrana.Vrchol2.GetKlic());
                        hrana.Vrchol2.SetKlic(fiktivniVrchol.Klic.GetKlic());
                        fiktivniHrana.Data.Nazev = "Fiktivní činnost";
                        fiktivniHrana.Data.Ohodnoceni = 0;
                        fiktivniHrana.Data.Typ = 2;
                        //pomPredHrana.Data.poleHran[0].Vrchol1.SetKlic(fiktivniHrana.Vrchol1.GetKlic());
                        //pomPredHrana.Data.poleHran[0].Vrchol2.SetKlic(fiktivniHrana.Vrchol2.GetKlic());
                        graf.VlozHranu(fiktivniHrana);
                    }
                    graf.VlozHranu(hrana);
                }
            }
            if (vlozeneCinnosti.Count == 0)
            {
                //MessageBox.Show("Graf nesplňuje podmínku počátečního uzlu.");
                cinnosti.Clear();
                foreach (Hrana polozka in puvodniCinnosti)
                {
                    cinnosti.Add(polozka);
                }
                return 0; //neni pocatecni vrchol
            }                
            foreach (Hrana polozka in vlozeneCinnosti)
            {
                cinnosti.OdeberHranu(polozka);
            }
            bool maPredchudce = true;
            int maxPredchudcu;
            SeznamHran adeptiNaVlozeni = new SeznamHran();
            while (cinnosti.Count > 0)
            {
                adeptiNaVlozeni.Clear();
                maxPredchudcu = 0;
                //prosel jsem vsechny cinnosti, pokud maji vlozene predchudce, tak je muzu vkladat od nejvetsiho poctu predchudcu
                foreach (Hrana polozka in cinnosti)
                {
                    maPredchudce = true;
                    for (int i = 0; i < polozka.Data.PoleHran.Length; i++)
                    {
                        Hrana hrana = new Hrana(polozka.Data.PoleHran[i].Vrchol1, polozka.Data.PoleHran[i].Vrchol2);
                        //pokud hrana nema zpracovane vsechny predchudce
                        if (vlozeneCinnosti.Najdi(hrana, 0) < 0)
                        {
                            maPredchudce = false;
                            break;
                        }
                    }
                    //maximalni pocet predchudcu
                    if (maPredchudce == true)
                    {
                        adeptiNaVlozeni.Add(polozka);
                        if (polozka.Data.PoleHran.Length > maxPredchudcu) maxPredchudcu = polozka.Data.PoleHran.Length;
                    }
                }
                Vrchol vrchol;
                Vrchol vrcholZ;
                if (adeptiNaVlozeni.Count == 0 && cinnosti.Count > 0)
                {
                    MessageBox.Show("Graf není acyklický nebo není souvislý.");
                    return 1;
                }
                while (adeptiNaVlozeni.Count > 0)
                {
                    foreach (Hrana polozka in adeptiNaVlozeni)
                    {
                        if (polozka.Data.PoleHran.Length == maxPredchudcu)
                        {
                            Vrchol vrchol2 = new Vrchol();
                            do
                            {
                                klic = "V" + posledniKlic.ToString("D3");
                                vrchol2.Klic.SetKlic(klic);
                                vrchol2.Nazev = klic;
                                pom = graf.VlozVrchol(vrchol2);
                                posledniKlic++;
                            } while (pom >= 1);
                            //prvni predchozi hrana
                            vrchol = null;
                            vrcholZ = null;
                            for (int j = 0; j < polozka.Data.PoleHran.Length; j++)
                            {
                                Hrana pomPredHrana = new Hrana(polozka.Data.PoleHran[j].Vrchol1, polozka.Data.PoleHran[j].Vrchol2);
                                pomPredHrana = (Hrana)(vlozeneCinnosti[vlozeneCinnosti.Najdi(pomPredHrana, 0)]);
                                Hrana pomGrafHrana = new Hrana(pomPredHrana.Data.PoleHran[0].Vrchol1, pomPredHrana.Data.PoleHran[0].Vrchol2);
                                //skutecna predchozi hrana grafu
                                pomGrafHrana = (Hrana)(graf.naslednici[graf.naslednici.Najdi(pomGrafHrana, 0)]);

                                if (j == 0)
                                {
                                    vrchol = new Vrchol(pomGrafHrana.Vrchol2.GetKlic());
                                    vrchol = (Vrchol)(graf.vrcholy[graf.vrcholy.Najdi(vrchol, 0)]);
                                    //nejjednodusi pripad - koncovy vrchol hrany ma vsechny predchudce, co ma vkladana cinnost
                                    Hrana vkladanaHrana = new Hrana(vrchol.Klic, vrchol2.Klic);
                                    polozka.Kopie2(vkladanaHrana);
                                    if (vlozeneCinnosti.Najdi(polozka, 0) >= 0)
                                    {
                                        vlozeneCinnosti.OdeberHranu(polozka);
                                    }
                                    vlozeneCinnosti.Add(polozka);
                                    zpracovaneCinnosti.Add(polozka);
                                    if (graf.naslednici.Najdi(vkladanaHrana, 0) >= 0)
                                    {
                                        Vrchol fiktivniVrchol = new Vrchol();
                                        //MessageBox.Show("2");
                                        klic = "V" + posledniKlic.ToString("D3");
                                        fiktivniVrchol.Klic.SetKlic(klic);
                                        fiktivniVrchol.Nazev = klic;
                                        pom = graf.VlozVrchol(fiktivniVrchol);
                                        posledniKlic++;
                                        Hrana fiktivniHrana = new Hrana();
                                        fiktivniHrana.Vrchol1.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                        fiktivniHrana.Vrchol2.SetKlic(vkladanaHrana.Vrchol2.GetKlic());
                                        vkladanaHrana.Vrchol2.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                        fiktivniHrana.Data.Nazev = "Fiktivní činnost";
                                        fiktivniHrana.Data.Ohodnoceni = 0;
                                        fiktivniHrana.Data.Typ = 2;
                                        //pomPredHrana.Data.poleHran[0].Vrchol1.SetKlic(fiktivniHrana.Vrchol1.GetKlic());
                                        //pomPredHrana.Data.poleHran[0].Vrchol2.SetKlic(fiktivniHrana.Vrchol2.GetKlic());
                                        graf.VlozHranu(fiktivniHrana);
                                    }
                                    else
                                    {
                                        bool predchudceNalezen = false;
                                        bool shodniPredchudci = true;
                                        SeznamHran seznamShodnychPredchudcu = new SeznamHran();
                                        if (vkladanaHrana.Data.Nazev == "Odstraňování závad při zkušebním provozu")
                                        {
                                            //MessageBox.Show("dsf");
                                        }
                                        foreach (Hrana predHrana in graf.IncidencePredchudci(vrchol))
                                        {
                                            predchudceNalezen=false;
                                            for (int k = 0; k < polozka.Data.PoleHran.Length; k++)
                                            {
                                                Hrana pomPredHrana2 = new Hrana(polozka.Data.PoleHran[k].Vrchol1, polozka.Data.PoleHran[k].Vrchol2);
                                                pomPredHrana2 = (Hrana)(vlozeneCinnosti[vlozeneCinnosti.Najdi(pomPredHrana2, 0)]);
                                                Hrana pomGrafHrana2 = new Hrana(pomPredHrana2.Data.PoleHran[0].Vrchol1, pomPredHrana2.Data.PoleHran[0].Vrchol2);
                                                //skutecna predchozi hrana grafu
                                                pomGrafHrana2 = (Hrana)(graf.naslednici[graf.naslednici.Najdi(pomGrafHrana2, 0)]);
                                                if (pomGrafHrana2.Vrchol1.GetKlic() == predHrana.Vrchol1.GetKlic() && pomGrafHrana2.Vrchol2.GetKlic() == predHrana.Vrchol2.GetKlic())
                                                {
                                                    predchudceNalezen = true;
                                                    seznamShodnychPredchudcu.Add(pomGrafHrana2);
                                                    break;
                                                }
                                            }
                                            if (predchudceNalezen==false) shodniPredchudci=false;
                                        }
                                        if (shodniPredchudci == false)
                                        {
                                            //MessageBox.Show("Nestejní předchůdci");
                                            Vrchol fiktivniVrchol = new Vrchol();
                                            klic = "V" + posledniKlic.ToString("D3");
                                            fiktivniVrchol.Klic.SetKlic(klic);
                                            fiktivniVrchol.Nazev = klic;
                                            pom = graf.VlozVrchol(fiktivniVrchol);
                                            posledniKlic++;
                                            /*foreach (Hrana innerItem in vlozeneCinnosti)
                                            {
                                                if (vkladanaHrana.Vrchol1.GetKlic() == innerItem.Data.PoleHran[0].Vrchol1.GetKlic() && vkladanaHrana.Vrchol2.GetKlic() == innerItem.Data.PoleHran[0].Vrchol2.GetKlic())
                                                {
                                                    innerItem.Data.PoleHran[0].Vrchol1.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                                    innerItem.Data.PoleHran[0].Vrchol2.SetKlic(vrchol2.Klic.GetKlic());
                                                }
                                            }*/
                                            vkladanaHrana.Vrchol1.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                            vkladanaHrana.Vrchol2.SetKlic(vrchol2.Klic.GetKlic());
                                            polozka.Data.PoleHran = null;
                                            polozka.Data.PoleHran = new ADTHrana[1];
                                            polozka.Data.PoleHran[0] = new ADTHrana(vkladanaHrana.Vrchol1.GetKlic(), vkladanaHrana.Vrchol2.GetKlic());
                                            Hrana fiktivniHrana = new Hrana();
                                            fiktivniHrana.Vrchol1.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                            fiktivniHrana.Vrchol2.SetKlic(vrchol.Klic.GetKlic());
                                            fiktivniHrana.Data.Nazev = "Fiktivní činnost";
                                            fiktivniHrana.Data.Ohodnoceni = 0;
                                            fiktivniHrana.Data.Typ = 2;
                                            graf.VlozHranu(fiktivniHrana);
                                            foreach (Hrana stejnaHrana in seznamShodnychPredchudcu)
                                            {
                                                graf.OdeberHranu(stejnaHrana);
                                            }
                                            foreach (Hrana zmenaKlic in seznamShodnychPredchudcu)
                                            {
                                                foreach (Hrana innerItem in vlozeneCinnosti)
                                                {
                                                    if (zmenaKlic.Vrchol1.GetKlic() == innerItem.Data.PoleHran[0].Vrchol1.GetKlic() && zmenaKlic.Vrchol2.GetKlic() == innerItem.Data.PoleHran[0].Vrchol2.GetKlic())
                                                    {
                                                        innerItem.Data.PoleHran[0].Vrchol2.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                                    }
                                                }
                                            }
                                            for (int q = 0; q < seznamShodnychPredchudcu.Count; q++)
                                            {
                                                Hrana zmenaHrana = (Hrana)(seznamShodnychPredchudcu[q]);
                                                zmenaHrana.Vrchol2.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                                graf.VlozHranu(zmenaHrana);
                                            }                                           
                                        }
                                    }
                                    graf.VlozHranu(vkladanaHrana);
                                    vrcholZ = new Vrchol();
                                    vrchol2.Kopie(vrcholZ);
                                    if (j == polozka.Data.PoleHran.Length - 1)
                                    {
                                        polozka.Data.PoleHran = null;
                                        polozka.Data.PoleHran = new ADTHrana[1];
                                        polozka.Data.PoleHran[0] = new ADTHrana(vkladanaHrana.Vrchol1.GetKlic(), vkladanaHrana.Vrchol2.GetKlic());
                                    }                                  
                                }
                                else
                                {
                                    //Hrana updateHrana = pomGrafHrana;
                                    graf.OdeberHranu(pomGrafHrana);
                                    pomGrafHrana.Vrchol2.SetKlic(vrchol.Klic.GetKlic());
                                    pomPredHrana.Data.poleHran[0].Vrchol2.SetKlic(pomGrafHrana.Vrchol2.GetKlic());
                                    if (vlozeneCinnosti.Najdi(polozka, 0) >= 0)
                                    {
                                        vlozeneCinnosti.OdeberHranu(polozka);
                                    }
                                    vlozeneCinnosti.Add(polozka);
                                    zpracovaneCinnosti.Add(polozka);
                                    if (graf.naslednici.Najdi(pomGrafHrana, 0) >= 0)
                                    {
                                        Vrchol fiktivniVrchol = new Vrchol();
                                        //MessageBox.Show("2");
                                        klic = "V" + posledniKlic.ToString("D3");
                                        fiktivniVrchol.Klic.SetKlic(klic);
                                        fiktivniVrchol.Nazev = klic;
                                        pom = graf.VlozVrchol(fiktivniVrchol);
                                        posledniKlic++;
                                        Hrana fiktivniHrana = new Hrana();
                                        fiktivniHrana.Vrchol1.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                        fiktivniHrana.Vrchol2.SetKlic(pomGrafHrana.Vrchol2.GetKlic());
                                        pomGrafHrana.Vrchol2.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                        fiktivniHrana.Data.Nazev = "Fiktivní činnost";
                                        fiktivniHrana.Data.Ohodnoceni = 0;
                                        fiktivniHrana.Data.Typ = 2;
                                        //pomPredHrana.Data.poleHran[0].Vrchol1.SetKlic(fiktivniHrana.Vrchol1.GetKlic());
                                        //pomPredHrana.Data.poleHran[0].Vrchol2.SetKlic(fiktivniHrana.Vrchol2.GetKlic());
                                        graf.VlozHranu(fiktivniHrana);
                                    }
                                    graf.VlozHranu(pomGrafHrana);
                                    if (j == polozka.Data.PoleHran.Length - 1)
                                    {
                                        polozka.Data.PoleHran = null;
                                        polozka.Data.PoleHran = new ADTHrana[1];
                                        polozka.Data.PoleHran[0] = new ADTHrana(vrchol.Klic.GetKlic(), vrcholZ.Klic.GetKlic());
                                    }
                                }
                            }
                        }
                    }
                    maxPredchudcu--;
                    foreach (Hrana polozka in vlozeneCinnosti)
                    {
                        cinnosti.OdeberHranu(polozka);
                        adeptiNaVlozeni.OdeberHranu(polozka);
                    }
                }
            }
            PoleVrcholu pole = new PoleVrcholu();
            PoleVrcholu poleKopie = new PoleVrcholu();
            foreach (Vrchol polozka in graf.vrcholy)
            {
                poleKopie.Add(polozka);
            }
            bool konec = false;
            Vrchol koncovyVrchol = null;
            foreach (Vrchol polozka in poleKopie)
            {
                if (polozka.PocetNasledniku == 0 && polozka.PocetPredchudcu == 0)
                {
                    pole.Add(polozka);
                }
                //koncove hrany
                if (polozka.PocetNasledniku == 0 && polozka.PocetPredchudcu > 0)
                {
                    if (konec == false)
                    {
                        koncovyVrchol = polozka;
                        konec = true;
                    }
                    else
                    {
                        for (int i = polozka.IndexPrvnihoPredchudce; i < polozka.IndexPrvnihoPredchudce + polozka.PocetPredchudcu; i++)
                        {
                            Hrana koncovaHrana = (Hrana)(graf.predchudci[i]);
                            Vrchol pomVrchol = new Vrchol(koncovaHrana.Vrchol2.GetKlic());
                            pole.Add(pomVrchol);
                            graf.OdeberHranu(koncovaHrana);
                            koncovaHrana.Vrchol2.SetKlic(koncovyVrchol.Klic.GetKlic());
                            if (graf.naslednici.Najdi(koncovaHrana, 0) >= 0)
                            {
                                Vrchol fiktivniVrchol = new Vrchol();
                                //MessageBox.Show("2");
                                klic = "V" + posledniKlic.ToString("D3");
                                fiktivniVrchol.Klic.SetKlic(klic);
                                fiktivniVrchol.Nazev = klic;
                                pom = graf.VlozVrchol(fiktivniVrchol);
                                posledniKlic++;
                                Hrana fiktivniHrana = new Hrana();
                                fiktivniHrana.Vrchol1.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                fiktivniHrana.Vrchol2.SetKlic(koncovaHrana.Vrchol2.GetKlic());
                                koncovaHrana.Vrchol2.SetKlic(fiktivniVrchol.Klic.GetKlic());
                                fiktivniHrana.Data.Nazev = "Fiktivní činnost";
                                fiktivniHrana.Data.Ohodnoceni = 0;
                                fiktivniHrana.Data.Typ = 2;
                                //pomPredHrana.Data.poleHran[0].Vrchol1.SetKlic(fiktivniHrana.Vrchol1.GetKlic());
                                //pomPredHrana.Data.poleHran[0].Vrchol2.SetKlic(fiktivniHrana.Vrchol2.GetKlic());
                                graf.VlozHranu(fiktivniHrana);
                            }
                            graf.VlozHranu(koncovaHrana);

                        }
                    }
                }
            }
            foreach (Vrchol polozka in pole)
            {
                graf.OdeberVrchol(polozka);
            }

            /*Hrana hrana = new Hrana();
            Vrchol vrchol1 = new Vrchol();
            Vrchol vrchol2 = new Vrchol();
            String klic;
            int pom;
            int posledniKlic = 0;
            do
                {
                    klic = "V" + posledniKlic.ToString("D4");
                    vrchol1.Klic.SetKlic(klic);
                    vrchol1.Nazev = klic;
                    pom = graf.VlozVrchol(vrchol1);
                    posledniKlic++;
                } while (pom >= 1);
            do
            {
                klic = "V" + posledniKlic.ToString("D4");
                vrchol2.Klic.SetKlic(klic);
                vrchol2.Nazev = klic;
                pom = graf.VlozVrchol(vrchol2);
                posledniKlic++;
            } while (pom >= 1);
            hrana.Vrchol1.SetKlic(vrchol1.Klic.GetKlic());
            hrana.Vrchol2.SetKlic(vrchol2.Klic.GetKlic());
            hrana.Data.Nazev = vrchol1.Klic.GetKlic() + vrchol2.Klic.GetKlic();
            graf.VlozHranu(hrana);*/
            return 0;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (cinnostiListView.SelectedIndices.Count != 1)
            {
                MessageBox.Show("Není vybrána pouze jedna položka", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            Hrana pomHrana = new Hrana();
            pomHrana.Vrchol1.SetKlic(cinnostiListView.SelectedItems[0].SubItems[0].Text);
            pomHrana.Vrchol2.SetKlic(cinnostiListView.SelectedItems[0].SubItems[1].Text);
            if (cinnosti.OdeberHranu(pomHrana) > 0)
                MessageBox.Show("Hrana nebyl smazána", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
            else Vypis();
        }
    }
}
