﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DiplomovaPrace
{
    public partial class DialogTerminRezerva : Form
    {
        private Vrchol uzel;

        public Vrchol Uzel
        {
            get { return uzel; }
            set { uzel = value; }
        }
        public DialogTerminRezerva()
        {
            InitializeComponent();
        }

        private void DialogTerminRezerva_Load(object sender, EventArgs e)
        {
            klicTextBox.Text = uzel.Klic.GetKlic();
            nazevTextBox.Text = uzel.Nazev;
            zacatekTextBox.Text = uzel.MinimalniCas.ToString();
            sigmaTextBox.Text = uzel.SigmaMin.ToString();
            planTextBox.Text = "0";
        }

        private void vypocetButton_Click(object sender, EventArgs e)
        {
            double pomOhodnoceni;
            if (!double.TryParse(planTextBox.Text, out pomOhodnoceni))
            {
                MessageBox.Show("Není vyplněno korektně plánovaný termín.", "Chyba v zadávání", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            double[] tabulka = new double[451];
            using (StreamReader sr = new StreamReader(File.OpenRead("normDistr.csv")))
            {
                for (int j = 0; j < 451; j++)
                {
                    string radek = sr.ReadLine();
                    string[] texty = radek.Split(';');
                    double pom;
                    double.TryParse(texty[0], out pom);
                    double.TryParse(texty[1], out pom);
                    tabulka[j] = pom;
                }
            }
            double FI = (uzel.MinimalniCas - uzel.MaximalniCas) / Math.Sqrt(Math.Pow(uzel.SigmaMin,2)+Math.Pow(uzel.SigmaMax,2));
            string cislo = String.Format("{0:F2}", FI);
            FI = double.Parse(cislo);
            int index;
            if (FI >= 4.5)
            {
                rezervaTextBox.Text = "100%";
            }
            if (FI < 4.5 && FI >= 0)
            {
                index = (int)(FI * 100);
                rezervaTextBox.Text = (tabulka[index]*100).ToString()+"%";
            }
            if (FI < 0 && FI>-4.5)
            {
                index = (int)(-FI * 100);
                rezervaTextBox.Text = ((1-tabulka[index])*100).ToString()+"%";
            }
            if (FI <= -4.5)
            {
                rezervaTextBox.Text = "0%";
            }
            FI = (pomOhodnoceni - uzel.MinimalniCas) / uzel.SigmaMin;
            cislo = String.Format("{0:F2}", FI);
            FI = double.Parse(cislo);
            if (FI >= 4.5)
            {
                terminTextBox.Text = "100%";
            }
            if (FI < 4.5 && FI >= 0)
            {
                index = (int)(FI * 100);
                terminTextBox.Text = (tabulka[index] * 100).ToString() + "%";
            }
            if (FI < 0 && FI > -4.5)
            {
                index = (int)(-FI * 100);
                terminTextBox.Text = ((1 - tabulka[index]) * 100).ToString() + "%";
            }
            if (FI <= -4.5)
            {
                terminTextBox.Text = "0%";
            }
            
            
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {

        }
    }
}
