﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DiplomovaPrace
{
    public partial class DialogVypis : Form
    {
        private VypocetPostup postup;
        private String nazevProjektu;

        public String NazevProjektu
        {
            get { return nazevProjektu; }
            set { nazevProjektu = value; }
        }

        public VypocetPostup Postup
        {
            get { return postup; }
            set { postup = value; }
        }

        public DialogVypis()
        {
            InitializeComponent();
        }
        public void Zobraz()
        {
            informaceAlgoritmusListBox.Items.Clear();
            informaceAlgoritmusListBox.BeginUpdate();
            foreach (String polozka in postup.VycetPostupu1)
            {
                informaceAlgoritmusListBox.Items.Add(polozka);
            }
            informaceAlgoritmusListBox.EndUpdate();
        }

        private void DialogVypis_Load(object sender, EventArgs e)
        {
            
        }

        private void DialogVypis_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.Hide();
            e.Cancel = true;
        }

        private void informaceAlgoritmusListBox_DoubleClick(object sender, EventArgs e)
        {
            if (informaceAlgoritmusListBox.SelectedIndices.Count != 1)
            {
                MessageBox.Show("Není vybrána pouze jedna položka", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            MessageBox.Show(informaceAlgoritmusListBox.SelectedItem.ToString(), "Info", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void ulozitButton_Click(object sender, EventArgs e)
        {
            saveFileDialog.FileName = (string)("Postup" + nazevProjektu + ".txt");
            if (saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                using (StreamWriter sw = new StreamWriter(File.Create(saveFileDialog.FileName), Encoding.UTF8))
                {
                    foreach (String polozka in postup.VycetPostupu1)
                    {
                        sw.WriteLine(polozka);
                    }
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
