﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DiplomovaPrace
{
    public partial class DialogVysledky : Form
    {
        private Vysledky vysledky;
        private String nazevProjektu;

        public String NazevProjektu
        {
            get { return nazevProjektu; }
            set { nazevProjektu = value; }
        }
        public Vysledky Vysledky
        {
            get { return vysledky; }
            set { vysledky = value; }
        }

        private double delkaProjektu;

        public double DelkaProjektu
        {
            get { return delkaProjektu; }
            set { delkaProjektu = value; }
        }
     
        public DialogVysledky()
        {
            InitializeComponent();
        }

        private void DialogVysledky_Load(object sender, EventArgs e)
        {
            
        }
        private void Vypis(VypocetPostup postup, ListBox listB)
        {
            listB.Items.Clear();
            listB.BeginUpdate();
            foreach (String polozka in postup.VycetPostupu1)
            {
                listB.Items.Add(polozka);
            }
            listB.EndUpdate();
        }
        private void Zapis(VypocetPostup postup, StreamWriter sw)
        {
            foreach (String polozka in postup.VycetPostupu1)
            {
                sw.WriteLine(polozka);
            }
        }

        public void Zobraz()
        {
            zdrojeProjektuListBox.Items.Clear();
            vytizeniZdrojuListBox.Items.Clear();
            nakladyListBox.Items.Clear();
            if (vysledky.Typ == 1)
            {
                button2.Hide();
                zdrojeProjektuListBox.Hide();
                vytizeniZdrojuListBox.Hide();
                nakladyListBox.Hide();
                label2.Hide();
                label7.Hide();
                label9.Hide();
                label5.Show();
                celkoveNakladyLabel.Hide();
                label4.Hide();
            }
            else
            {
                button2.Show();
                zdrojeProjektuListBox.Show();
                vytizeniZdrojuListBox.Show();
                nakladyListBox.Show();
                label2.Show();
                label7.Show();
                label9.Show();
                label5.Hide();
                celkoveNakladyLabel.Show();
                label4.Show();
            }
            nazevProjektuLabel.Text = vysledky.NazevProjektu;
            zacatekProjektuLabel.Text = vysledky.ZacatekProjektu.ToLongDateString();
            konecProjektuLabel.Text = vysledky.KonecProjektu.ToLongDateString();
            dobaTrvaniLabel.Text = vysledky.DelkaProjektu.ToString() + " (ve dnech)";
            if (vysledky.Typ == 0)
            {
                Vypis(vysledky.VycetZdroju, zdrojeProjektuListBox);
                Vypis(vysledky.VytizenostZdroju, vytizeniZdrojuListBox);
            }
            Vypis((VypocetPostup)vysledky.Reseni[0], reseniListBox);
            if (vysledky.Typ == 0)
            {
                reseniComboBox.Show();
                reseniComboBox.Items.Clear();
                for (int i = 0; i < vysledky.Reseni.Count; i++)
                {
                    reseniComboBox.Items.Add("Řešení " + (i + 1).ToString());
                }
                reseniComboBox.SelectedIndex = 0;
            }
            else reseniComboBox.Hide();
            if (vysledky.Typ == 0)
            {
                Vypis(vysledky.NakladyProjektu, nakladyListBox);
                celkoveNakladyLabel.Text = String.Format("{0:N}", vysledky.CelkoveNaklady);
            }
        }
        private void reseniComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            Vypis((VypocetPostup)vysledky.Reseni[reseniComboBox.SelectedIndex], reseniListBox);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void DialogVysledky_Shown(object sender, EventArgs e)
        {
            
        }

        private void DialogVysledky_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            saveFileDialog.FileName = (string)("Vysledky" + nazevProjektu + ".txt");
            if (saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                using (StreamWriter sw = new StreamWriter(File.Create(saveFileDialog.FileName),Encoding.UTF8))
                {
                    sw.WriteLine("Projekt: " + vysledky.NazevProjektu);
                    sw.WriteLine("Začátek projekut: " + vysledky.ZacatekProjektu.ToLongDateString());
                    sw.WriteLine("Začátek projekut: " + vysledky.KonecProjektu.ToLongDateString());
                    sw.WriteLine("Délka projektu: " + vysledky.DelkaProjektu.ToString() + " (ve dnech)");
                    sw.WriteLine("Přehled zdrojů projektu");
                    Zapis(vysledky.VycetZdroju, sw);
                    sw.WriteLine("Vytíženost zdrojů");
                    Zapis(vysledky.VytizenostZdroju, sw);
                    sw.WriteLine("Přehled nákladů projektu");
                    Zapis(vysledky.NakladyProjektu, sw);
                    sw.WriteLine("Celkové náklady: " + String.Format("{0:N}", vysledky.CelkoveNaklady));
                    sw.WriteLine("");
                    for (int i = 0; i < vysledky.Reseni.Count; i++)
                    {
                        sw.WriteLine("Řešení " + (i+1).ToString());
                        Zapis((VypocetPostup)vysledky.Reseni[i], sw);
                        sw.WriteLine("");
                    }
                    
                }
            }
        }

        private void saveFileDialog_FileOk(object sender, CancelEventArgs e)
        {

        }

    }
}
