﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

///<summary>
///Třída reprezentující klíč vrcholu - klíč je datového typu <c>String</c>
///Parametrický konstruktor pro nastavení hodnoty klíče
///Metody SetKlic a GetKlic jsou pro nastavení, respektive získaní klíče
///Přetížené operátory pro porovnávání <, >, ==, !=
///</summary>

namespace DiplomovaPrace
{
    public class KlicVrchol
    {
        private String klic;
        public KlicVrchol(String klic)
        {
            this.klic = klic;
        }
        /// <summary>
        /// Nastaví hodnotu klíče.
        /// </summary>
        /// <param name="klic"></param>
        public void SetKlic(String klic)
        {
            this.klic = klic;
        }
        public String GetKlic()
        {
            return this.klic;
        }
        public override int GetHashCode()
        {
            return base.GetHashCode();
        }
        public override bool Equals(object obj)
        {
            KlicVrchol other = obj as KlicVrchol;
            if (other == null) return false;
            return (this.klic == other.klic);
        }
        public int CompareTo(object klic)
        {
            if (String.Compare(this.klic, ((KlicVrchol)klic).klic) == 1)
                return 1;
            else
                if (String.Compare(this.klic, ((KlicVrchol)klic).klic) == -1)
                    return -1;
                else
                    return 0;
        }
        public static bool operator ==(KlicVrchol klic1, KlicVrchol klic2)
        {
            return klic1.Equals(klic2);
        }
        public static bool operator !=(KlicVrchol klic1, KlicVrchol klic2)
        {
            return !klic1.Equals(klic2);
        }
        public void Nacti(StreamReader sr)
        {
            klic = sr.ReadLine();
        }
        public void Nacti(BinaryReader br)
        {
            klic = br.ReadString();
        }
        public void Uloz(BinaryWriter bw)
        {
            bw.Write(klic);
        }
        public void Uloz(StreamWriter sw)
        {
            sw.WriteLine(klic);
        }
    }
}
