﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Windows.Forms;

namespace DiplomovaPrace
{
    public class NastaveniVzhled
    {
        private Font pismoFont = new Font("Arial", 12);
        private Font hranaFont = new Font("Arial", 8);
        private SolidBrush barvaPismaVrchol = new SolidBrush(Color.Black);
        private SolidBrush barvaPismaHrana = new SolidBrush(Color.Black);
        private Color barva1Vrchol = Color.Aqua;
        private Color barva2Vrchol = Color.Blue;
        private Color barva1NejUzel = Color.Red;
        private Color barva2NejUzel = Color.Pink;
        private Color barva1Hrana = Color.Black;
        private Color barva2Hrana = Color.Blue;
        private Color barva1NejHrana = Color.Yellow;
        private Color barva2NejHrana = Color.Green;
        private Color barva1KritickaHrana = Color.DarkRed;
        private Color barva2KritickaHrana = Color.Red;
        private Color barva1FiktivniHrana = Color.Black;
        private Color barva2FiktivniHrana = Color.Black;
        private Color barva1Rezerva = Color.DarkTurquoise;
        private Color barva2Rezerva = Color.Green;
        private Color barva1FiktivniKritickaHrana = Color.Red;
        private Color barva2FiktivniKritickaHrana = Color.Red;
        private Color barva1Zavislost = Color.Blue;
        private Color barva2Zavislost = Color.Blue;
        private Color barva1KritickaZavislost = Color.Red;
        private Color barva2KritickaZavislost = Color.Red;
        private Color barva1FiktivniZavislost = Color.Blue;
        private Color barva2FiktivniZavislost = Color.Blue;
        private Color barva1FiktivniKritickaZavislost = Color.DarkRed;
        private Color barva2FiktivniKritickaZavislost = Color.DarkRed;
        private bool zobrazitRezervy = true;
        private bool zobrazitZavislosti = true;
        private bool zobrazitGrid = true;
        private float zoomTest = 1;
        private int meritko = 1;
        private int velikost = 10;
        private int tloustka = 4;
        private int tloustka2 = 2;
        private int tvar = 0;
        private int zobrazeniInformaci = 0;
        private bool fixedInfo = true;
        private bool zobrazitVsechnaReseni = false;
        private bool vyukovyMod = false;
        private string jednotky = "dny";
        private int popisCinnosti = 0; //zkratky
        private bool zobrazitCinnostOhodnoceni = true;
        private bool zobrazitUzelNazev = true;
        private bool zobrazitUzelCasy = true;
        private bool grafickyPostup = false;
        private bool jednoReseni = true;


        #region vlastnosti
        public bool JednoReseni
        {
            get { return jednoReseni; }
            set { jednoReseni = value; }
        }


        public bool GrafickyPostup
        {
            get { return grafickyPostup; }
            set { grafickyPostup = value; }
        }
        public bool ZobrazitUzelCasy
        {
            get { return zobrazitUzelCasy; }
            set { zobrazitUzelCasy = value; }
        }

        public bool ZobrazitUzelNazev
        {
            get { return zobrazitUzelNazev; }
            set { zobrazitUzelNazev = value; }
        }
        public bool ZobrazitCinnostOhodnoceni
        {
            get { return zobrazitCinnostOhodnoceni; }
            set { zobrazitCinnostOhodnoceni = value; }
        }
        /// <summary>
        /// Popis činností.
        /// 0 - zkratka
        /// 1 - název
        /// 2 - žádný
        /// </summary>
        /// 
        public int PopisCinnosti
        {
            get { return popisCinnosti; }
            set { popisCinnosti = value; }
        }
        public string Jednotky
        {
            get { return jednotky; }
            set { jednotky = value; }
        }
        public bool VyukovyMod
        {
            get { return vyukovyMod; }
            set { vyukovyMod = value; }
        }
        public bool ZobrazitVsechnaReseni
        {
            get { return zobrazitVsechnaReseni; }
            set { zobrazitVsechnaReseni = value; }
        }
        public bool FixedInfo
        {
            get { return fixedInfo; }
            set { fixedInfo = value; }
        }
        public int ZobrazeniInformaci
        {
            get { return zobrazeniInformaci; }
            set { zobrazeniInformaci = value; }
        }

        public Color Barva1NejUzel
        {
            get { return barva1NejUzel; }
            set { barva1NejUzel = value; }
        }
        public Color Barva2NejUzel
        {
            get { return barva2NejUzel; }
            set { barva2NejUzel = value; }
        }
        public Color Barva1NejHrana
        {
            get { return barva1NejHrana; }
            set { barva1NejHrana = value; }
        }
        public Color Barva2NejHrana
        {
            get { return barva2NejHrana; }
            set { barva2NejHrana = value; }
        }
        public Color Barva1KritickaHrana
        {
            get { return barva1KritickaHrana; }
            set { barva1KritickaHrana = value; }
        }
        public Color Barva2KritickaHrana
        {
            get { return barva2KritickaHrana; }
            set { barva2KritickaHrana = value; }
        }
        public Color Barva1FiktivniHrana
        {
            get { return barva1FiktivniHrana; }
            set { barva1FiktivniHrana = value; }
        }
        public Color Barva2FiktivniHrana
        {
            get { return barva2FiktivniHrana; }
            set { barva2FiktivniHrana = value; }
        }
        public Color Barva1Rezerva
        {
            get { return barva1Rezerva; }
            set { barva1Rezerva = value; }
        }
        public Color Barva2Rezerva
        {
            get { return barva2Rezerva; }
            set { barva2Rezerva = value; }
        }
        public Color Barva1FiktivniKritickaHrana
        {
            get { return barva1FiktivniKritickaHrana; }
            set { barva1FiktivniKritickaHrana = value; }
        }
        public Color Barva2FiktivniKritickaHrana
        {
            get { return barva2FiktivniKritickaHrana; }
            set { barva2FiktivniKritickaHrana = value; }
        }
        public Color Barva1Zavislost
        {
            get { return barva1Zavislost; }
            set { barva1Zavislost = value; }
        }
        public Color Barva2Zavislost
        {
            get { return barva2Zavislost; }
            set { barva2Zavislost = value; }
        }
        public Color Barva1KritickaZavislost
        {
            get { return barva1KritickaZavislost; }
            set { barva1KritickaZavislost = value; }
        }
        public Color Barva2KritickaZavislost
        {
            get { return barva2KritickaZavislost; }
            set { barva2KritickaZavislost = value; }
        }
        public Color Barva1FiktivniZavislost
        {
            get { return barva1FiktivniZavislost; }
            set { barva1FiktivniZavislost = value; }
        }
        public Color Barva2FiktivniZavislost
        {
            get { return barva2FiktivniZavislost; }
            set { barva2FiktivniZavislost = value; }
        }
        public Color Barva1FiktivniKritickaZavislost
        {
            get { return barva1FiktivniKritickaZavislost; }
            set { barva1FiktivniKritickaZavislost = value; }
        }
        public Color Barva2FiktivniKritickaZavislost
        {
            get { return barva2FiktivniKritickaZavislost; }
            set { barva2FiktivniKritickaZavislost = value; }
        }
        public int Tloustka2
        {
            get { return tloustka2; }
            set { tloustka2 = value; }
        }
        public int Tloustka
        {
            get { return tloustka; }
            set { tloustka = value; }
        }
        public float ZoomTest
        {
            get { return zoomTest; }
            set { zoomTest = value; }
        }
        public int Meritko
        {
            get { return meritko; }
            set { meritko = value; }
        }
        public int Velikost
        {
            get { return velikost; }
            set { velikost = value; }
        }
        public int Tvar
        {
            get { return tvar; }
            set { tvar = value; }
        }
        public bool ZobrazitGrid
        {
            get { return zobrazitGrid; }
            set { zobrazitGrid = value; }
        }
        public bool ZobrazitZavislosti
        {
            get { return zobrazitZavislosti; }
            set { zobrazitZavislosti = value; }
        }
        public bool ZobrazitRezervy
        {
            get { return zobrazitRezervy; }
            set { zobrazitRezervy = value; }
        }
        public SolidBrush BarvaPismaVrchol
        {
            get { return barvaPismaVrchol; }
            set { barvaPismaVrchol = value; }
        }
        public SolidBrush BarvaPismaHrana
        {
            get { return barvaPismaHrana; }
            set { barvaPismaHrana = value; }
        }
        public Font PismoFont
        {
            get { return pismoFont; }
            set { pismoFont = value; }
        }
        public Font HranaFont
        {
            get { return hranaFont; }
            set { hranaFont = value; }
        }
        public Color Barva2Vrchol
        {
            get { return barva2Vrchol; }
            set { barva2Vrchol = value; }
        }
        public Color Barva1Vrchol
        {
            get { return barva1Vrchol; }
            set { barva1Vrchol = value; }
        }
        public Color Barva1Hrana
        {
            get { return barva1Hrana; }
            set { barva1Hrana = value; }
        }
        public Color Barva2Hrana
        {
            get { return barva2Hrana; }
            set { barva2Hrana = value; }
        }
        #endregion
        private uint ColorToUInt(Color color)
        {
            return (uint)((color.A << 24) | (color.R << 16) |
                          (color.G << 8) | (color.B << 0));
        }
        private Color UIntToColor(uint color)
        {
            byte a = (byte)(color >> 24);
            byte r = (byte)(color >> 16);
            byte g = (byte)(color >> 8);
            byte b = (byte)(color >> 0);
            return Color.FromArgb(a, r, g, b);
        }
        public void Uloz()
        {
            BinaryFormatter bf = new BinaryFormatter();
            using (FileStream fs = new FileStream("nastaveni.cfg", FileMode.Create))
            {
                bf.Serialize(fs, pismoFont);
                bf.Serialize(fs, hranaFont);
                using (BinaryWriter bw = new BinaryWriter(fs))
                {
                    bw.Write(ColorToUInt(barvaPismaVrchol.Color));
                    bw.Write(ColorToUInt(barvaPismaHrana.Color));
                    bw.Write(ColorToUInt(barva1Vrchol));
                    bw.Write(ColorToUInt(barva2Vrchol));
                    bw.Write(ColorToUInt(barva1NejUzel));
                    bw.Write(ColorToUInt(barva2NejUzel));
                    bw.Write(ColorToUInt(barva1Hrana));
                    bw.Write(ColorToUInt(barva2Hrana));
                    bw.Write(ColorToUInt(barva1NejHrana));
                    bw.Write(ColorToUInt(barva2NejHrana));
                    bw.Write(ColorToUInt(barva1KritickaHrana));
                    bw.Write(ColorToUInt(barva2KritickaHrana));
                    bw.Write(ColorToUInt(barva1FiktivniHrana));
                    bw.Write(ColorToUInt(barva2FiktivniHrana));
                    bw.Write(ColorToUInt(barva1Rezerva));
                    bw.Write(ColorToUInt(barva2Rezerva));
                    bw.Write(ColorToUInt(barva1FiktivniKritickaHrana));
                    bw.Write(ColorToUInt(barva2FiktivniKritickaHrana));
                    bw.Write(ColorToUInt(barva1Zavislost));
                    bw.Write(ColorToUInt(barva2Zavislost));
                    bw.Write(ColorToUInt(barva1KritickaZavislost));
                    bw.Write(ColorToUInt(barva2KritickaZavislost));
                    bw.Write(ColorToUInt(barva1FiktivniZavislost));
                    bw.Write(ColorToUInt(barva2FiktivniZavislost));
                    bw.Write(ColorToUInt(barva1FiktivniKritickaZavislost));
                    bw.Write(ColorToUInt(barva2FiktivniKritickaZavislost));
                    bw.Write(zobrazitRezervy);
                    bw.Write(zobrazitZavislosti);
                    bw.Write(zobrazitGrid);
                    bw.Write(velikost);
                    bw.Write(tloustka);
                    bw.Write(tloustka2);
                    bw.Write(tvar);
                    bw.Write(zobrazeniInformaci);
                    bw.Write(fixedInfo);
                    bw.Write(zobrazitVsechnaReseni);
                    bw.Write(vyukovyMod);
                    bw.Write(jednotky);
                    bw.Write(popisCinnosti);
                    bw.Write(zobrazitCinnostOhodnoceni);
                    bw.Write(zobrazitUzelNazev);
                    bw.Write(zobrazitUzelCasy);
                    bw.Write(grafickyPostup);
                }
            }
        }
        public void Nacti()
        {
            BinaryFormatter bf = new BinaryFormatter();
            try
            {
                using (FileStream fs = new FileStream("nastaveni.cfg", FileMode.Open))
                {
                    pismoFont = (Font)bf.Deserialize(fs);
                    hranaFont = (Font)bf.Deserialize(fs);
                    using (BinaryReader br = new BinaryReader(fs))
                    {
                        barvaPismaVrchol.Color = UIntToColor(br.ReadUInt32());
                        barvaPismaHrana.Color = UIntToColor(br.ReadUInt32());
                        barva1Vrchol = UIntToColor(br.ReadUInt32());
                        barva2Vrchol = UIntToColor(br.ReadUInt32());
                        barva1NejUzel = UIntToColor(br.ReadUInt32());
                        barva2NejUzel = UIntToColor(br.ReadUInt32());
                        barva1Hrana = UIntToColor(br.ReadUInt32());
                        barva2Hrana = UIntToColor(br.ReadUInt32());
                        barva1NejHrana = UIntToColor(br.ReadUInt32());
                        barva2NejHrana = UIntToColor(br.ReadUInt32());
                        barva1KritickaHrana = UIntToColor(br.ReadUInt32());
                        barva2KritickaHrana = UIntToColor(br.ReadUInt32());
                        barva1FiktivniHrana = UIntToColor(br.ReadUInt32());
                        barva2FiktivniHrana = UIntToColor(br.ReadUInt32());
                        barva1Rezerva = UIntToColor(br.ReadUInt32());
                        barva2Rezerva = UIntToColor(br.ReadUInt32());
                        barva1FiktivniKritickaHrana = UIntToColor(br.ReadUInt32());
                        barva2FiktivniKritickaHrana = UIntToColor(br.ReadUInt32());
                        barva1Zavislost = UIntToColor(br.ReadUInt32());
                        barva2Zavislost = UIntToColor(br.ReadUInt32());
                        barva1KritickaZavislost = UIntToColor(br.ReadUInt32());
                        barva2KritickaZavislost = UIntToColor(br.ReadUInt32());
                        barva1FiktivniZavislost = UIntToColor(br.ReadUInt32());
                        barva2FiktivniZavislost = UIntToColor(br.ReadUInt32());
                        barva1FiktivniKritickaZavislost = UIntToColor(br.ReadUInt32());
                        barva2FiktivniKritickaZavislost = UIntToColor(br.ReadUInt32());
                        zobrazitRezervy = br.ReadBoolean();
                        zobrazitZavislosti = br.ReadBoolean();
                        zobrazitGrid = br.ReadBoolean();
                        velikost = br.ReadInt32();
                        tloustka = br.ReadInt32();
                        tloustka2 = br.ReadInt32();
                        tvar = br.ReadInt32();
                        zobrazeniInformaci = br.ReadInt32();
                        fixedInfo = br.ReadBoolean();
                        zobrazitVsechnaReseni = br.ReadBoolean();
                        vyukovyMod = br.ReadBoolean();
                        jednotky = br.ReadString();
                        popisCinnosti = br.ReadInt32();
                        zobrazitCinnostOhodnoceni = br.ReadBoolean();
                        zobrazitUzelNazev = br.ReadBoolean();
                        zobrazitUzelCasy = br.ReadBoolean();
                        grafickyPostup = br.ReadBoolean();
                    }
                }
            }
            catch (Exception except)
            {
                Exception ex = except;
                MessageBox.Show(except.Message);
                //nedelam nic, necham obyc konfiguraci
            }
        }
    }
}
