﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.IO;

namespace DiplomovaPrace
{
    public class CompareKlic : IComparer
    {
        private bool vzestupne;
        public CompareKlic(bool vzestupne)
        {
            this.vzestupne = vzestupne;
        }
        public int Compare(object x, object y)
        {
            if (vzestupne) return string.Compare(((Vrchol)x).Klic.GetKlic(), ((Vrchol)y).Klic.GetKlic());
            return string.Compare(((Vrchol)y).Klic.GetKlic(), ((Vrchol)x).Klic.GetKlic());
        }
    }
    public class CompareNazev : IComparer
    {
        private bool vzestupne;
        public CompareNazev(bool vzestupne)
        {
            this.vzestupne = vzestupne;
        }
        public int Compare(object x, object y)
        {
            if (vzestupne) return string.Compare(((Vrchol)x).Nazev, ((Vrchol)y).Nazev);
            return string.Compare(((Vrchol)y).Nazev, ((Vrchol)x).Nazev);
        }
    }
    public class CompareOhodnoceni : IComparer
    {
        private bool vzestupne;
        public CompareOhodnoceni(bool vzestupne)
        {
            this.vzestupne = vzestupne;
        }
        public int Compare(object x, object y)
        {
            if (vzestupne) return ((Vrchol)x).MaximalniCas.CompareTo(((Vrchol)y).MaximalniCas);
            return ((Vrchol)y).MaximalniCas.CompareTo(((Vrchol)x).MaximalniCas);
        }
    }

    public class PoleVrcholu : SortedArrayList
    {
        public PoleVrcholu()
        {
            Comparer = new CompareKlic(true);
        }
        public void Uloz(StreamWriter sw)
        {
            sw.WriteLine(Count);
            for (int i = 0; i < Count; i++)
            {
                ((Vrchol)base[i]).Uloz(sw);
            }
        }
        public int Nacti(StreamReader sr)
        {
            int pocet = 0;
            try
            {
                pocet = Int32.Parse(sr.ReadLine());
                for (int i = 0; i < pocet; i++)
                {
                    Vrchol vrchol = new Vrchol();
                    vrchol.Nacti(sr);
                    Add(vrchol);
                }
            }
            catch (Exception except)
            {
                throw new Exception("Špatný formát souboru.", except);
            }
            return pocet;
        }
        public void Uloz(BinaryWriter bw)
        {
            bw.Write(Count);
            for (int i = 0; i < Count; i++)
            {
                ((Vrchol)base[i]).Uloz(bw);
            }
        }
        public int Nacti(BinaryReader br)
        {
            int pocet = br.ReadInt32();
            for (int i = 0; i < pocet; i++)
            {
                Vrchol vrchol = new Vrchol();
                vrchol.Nacti(br);
                Add(vrchol);
            }
            return pocet;
        }
        public int Najdi(object value, int index)
        {
            switch (index)
            {
                case 0:
                    if ((Comparer is CompareKlic) && Sorted == true)
                    {
                        return IndexOf(value, Comparer);
                    }
                    return Sekvencne(value, new CompareKlic(true));
                case 1:
                    if ((Comparer is CompareNazev) && Sorted == true)
                    {
                        return IndexOf(value, Comparer);
                    }
                    return Sekvencne(value, new CompareNazev(true));
                case 2:
                    if ((Comparer is CompareOhodnoceni) && Sorted == true)
                    {
                        return IndexOf(value, Comparer);
                    }
                    return Sekvencne(value, new CompareOhodnoceni(true));
            }
                    return -1;
            }        
    }
}
