﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Collections;

namespace DiplomovaPrace
{

    public class  CompareKlicHrana : IComparer
    {
        private bool vzestupne;
        public CompareKlicHrana(bool vzestupne)
        {
            this.vzestupne = vzestupne;
        }
        public int Compare(object x, object y)
        {
            if (vzestupne) return string.Compare(((Hrana)x).Vrchol1.GetKlic() + ((Hrana)x).Vrchol2.GetKlic(), ((Hrana)y).Vrchol1.GetKlic() + ((Hrana)y).Vrchol2.GetKlic());
            return string.Compare(((Hrana)y).Vrchol1.GetKlic() + ((Hrana)y).Vrchol2.GetKlic(), ((Hrana)x).Vrchol1.GetKlic() + ((Hrana)x).Vrchol2.GetKlic());
        }
    }
    public class CompareNazevHrana : IComparer
    {
        private bool vzestupne;
        public CompareNazevHrana(bool vzestupne)
        {
            this.vzestupne = vzestupne;
        }
        public int Compare(object x, object y)
        {
            if (vzestupne) return string.Compare(((Hrana)x).Data.Nazev, ((Hrana)y).Data.Nazev);
            return string.Compare(((Hrana)y).Data.Nazev, ((Hrana)x).Data.Nazev);
        }
    }
    public class CompareOhodnoceniHrana : IComparer
    {
        private bool vzestupne;
        public CompareOhodnoceniHrana(bool vzestupne)
        {
            this.vzestupne = vzestupne;
        }
        public int Compare(object x, object y)
        {
            if (vzestupne) return ((Hrana)x).Data.Ohodnoceni.CompareTo(((Hrana)y).Data.Ohodnoceni);
            return ((Hrana)y).Data.Ohodnoceni.CompareTo(((Hrana)x).Data.Ohodnoceni);
        }
    }

       public class SeznamHran : SortedArrayList
       {
            public SeznamHran()
            {
                Comparer = new CompareNazevHrana(true);
            }
            public int Najdi(object value, int index)
            {
                switch (index)
                {
                    case 0:
                        if ((Comparer is CompareKlicHrana) && Sorted == true)
                        {
                            return IndexOf(value, Comparer);
                        }
                        return Sekvencne(value, new CompareKlicHrana(true));
                    case 1:
                        if ((Comparer is CompareNazevHrana) && Sorted == true)
                        {
                            return IndexOf(value, Comparer);
                        }
                        return Sekvencne(value, new CompareNazevHrana(true));
                    case 2:
                        if ((Comparer is CompareOhodnoceniHrana) && Sorted == true)
                        {
                            return IndexOf(value, Comparer);
                        }
                        return Sekvencne(value, new CompareOhodnoceniHrana(true));
                }
                return -1;
            }
           /// <summary>
           /// Odstraní hranu z ArrayListu.
           /// </summary>
           /// <param name="hrana"></param>
           /// <returns>Vrací <c>int</c> 0 - bez chyby, jinak -1, pokud nebyla hrana odebrána.</returns>
            public int OdeberHranu(Hrana hrana)
            {
                int index = Najdi(hrana, 0);
                if (index < 0) return -1;
                RemoveAt(index);
                return 0;
            }
        }
    }
