﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.IO;

namespace DiplomovaPrace
{
        public class CompareNazevZdrojHrany : IComparer
        {
            private bool vzestupne;
            public CompareNazevZdrojHrany(bool vzestupne)
            {
                this.vzestupne = vzestupne;
            }
            public int Compare(object x, object y)
            {
                if (vzestupne) return string.Compare(((ZdrojHrany)x).Nazev, ((ZdrojHrany)y).Nazev);
                return string.Compare(((ZdrojHrany)y).Nazev, ((ZdrojHrany)x).Nazev);
            }
        }
        public class CompareSpotreba : IComparer
        {
            private bool vzestupne;
            public CompareSpotreba(bool vzestupne)
            {
                this.vzestupne = vzestupne;
            }
            public int Compare(object x, object y)
            {
                if (vzestupne) return ((ZdrojHrany)x).Spotreba.CompareTo(((ZdrojHrany)y).Spotreba);
                return ((ZdrojHrany)y).Spotreba.CompareTo(((ZdrojHrany)x).Spotreba);
            }
        }
        public class SeznamZdrojeHrany : SortedArrayList
        {
            public SeznamZdrojeHrany()
            {
                Comparer = new CompareNazevZdrojHrany(true);
            }
            public void Uloz(StreamWriter sw)
            {
                sw.WriteLine(Count);
                for (int i = 0; i < Count; i++)
                {
                    ((ZdrojHrany)base[i]).Uloz(sw);
                }
            }
            public int Nacti(StreamReader sr)
            {
                int pocet = Int32.Parse(sr.ReadLine());
                for (int i = 0; i < pocet; i++)
                {
                    ZdrojHrany zdroj = new ZdrojHrany();
                    zdroj.Nacti(sr);
                    Add(zdroj);
                }
                return pocet;
            }
            public void Uloz(BinaryWriter bw)
            {
                bw.Write(Count);
                for (int i = 0; i < Count; i++)
                {
                    ((ZdrojHrany)base[i]).Uloz(bw);
                }
            }
            public int Nacti(BinaryReader br)
            {
                int pocet = br.ReadInt32();
                for (int i = 0; i < pocet; i++)
                {
                    ZdrojHrany zdroj = new ZdrojHrany();
                    zdroj.Nacti(br);
                    Add(zdroj);
                }
                return pocet;
            }
            public int Najdi(object value, int index)
            {
                switch (index)
                {
                    case 0:
                        if ((Comparer is CompareNazevZdrojHrany) && Sorted == true)
                        {
                            return IndexOf(value, Comparer);
                        }
                        return Sekvencne(value, new CompareNazevZdrojHrany(true));
                    case 1:
                        if ((Comparer is CompareSpotreba) && Sorted == true)
                        {
                            return IndexOf(value, Comparer);
                        }
                        return Sekvencne(value, new CompareSpotreba(true));
                }
                return -1;
            }
        }
    
}
