﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.IO;

namespace DiplomovaPrace
{
     public class CompareNazevZdroj : IComparer
        {
            private bool vzestupne;
            public CompareNazevZdroj(bool vzestupne)
            {
                this.vzestupne = vzestupne;
            }
            public int Compare(object x, object y)
            {
                if (vzestupne) return string.Compare(((Zdroj)x).Nazev, ((Zdroj)y).Nazev);
                return string.Compare(((Zdroj)y).Nazev, ((Zdroj)x).Nazev);
            }
        }
        public class ComparePuvodniKapacita : IComparer
        {
            private bool vzestupne;
            public ComparePuvodniKapacita(bool vzestupne)
            {
                this.vzestupne = vzestupne;
            }
            public int Compare(object x, object y)
            {
                if (vzestupne) return ((Zdroj)x).PuvodniKapacita.CompareTo(((Zdroj)y).PuvodniKapacita);
                return ((Zdroj)y).PuvodniKapacita.CompareTo(((Zdroj)x).PuvodniKapacita);
            }
        }
        public class CompareAktualniKapacita : IComparer
        {
            private bool vzestupne;
            public CompareAktualniKapacita(bool vzestupne)
            {
                this.vzestupne = vzestupne;
            }
            public int Compare(object x, object y)
            {
                if (vzestupne) return ((Zdroj)x).AktualniKapacita.CompareTo(((Zdroj)y).AktualniKapacita);
                return ((Zdroj)y).AktualniKapacita.CompareTo(((Zdroj)x).AktualniKapacita);
            }
        }

        public class SeznamZdroju : SortedArrayList
        {
            public SeznamZdroju()
            {
                Comparer = new CompareNazevZdroj(true);
            }
            public void Uloz(StreamWriter sw)
            {
                sw.WriteLine(Count);
                for (int i = 0; i < Count; i++)
                {
                    ((Zdroj)base[i]).Uloz(sw);
                }
            }
            public int Nacti(StreamReader sr)
            {
                int pocet = Int32.Parse(sr.ReadLine());
                for (int i = 0; i < pocet; i++)
                {
                    Zdroj zdroj = new Zdroj();
                    zdroj.Nacti(sr);
                    Add(zdroj);
                }
                return pocet;
            }
            public void Uloz(BinaryWriter bw)
            {
                bw.Write(Count);
                for (int i = 0; i < Count; i++)
                {
                    ((Zdroj)base[i]).Uloz(bw);
                }
            }
            public int Nacti(BinaryReader br)
            {
                int pocet = br.ReadInt32();
                for (int i = 0; i < pocet; i++)
                {
                    Zdroj zdroj = new Zdroj();
                    zdroj.Nacti(br);
                    Add(zdroj);
                }
                return pocet;
            }
            public int Najdi(object value, int index)
            {
                switch (index)
                {
                    case 0:
                        if ((Comparer is CompareNazevZdroj) && Sorted == true)
                        {
                            return IndexOf(value, Comparer);
                        }
                        return Sekvencne(value, new CompareNazevZdroj(true));
                    case 1:
                        if ((Comparer is ComparePuvodniKapacita) && Sorted == true)
                        {
                            return IndexOf(value, Comparer);
                        }
                        return Sekvencne(value, new ComparePuvodniKapacita(true));
                    case 2:
                        if ((Comparer is CompareAktualniKapacita) && Sorted == true)
                        {
                            return IndexOf(value, Comparer);
                        }
                        return Sekvencne(value, new CompareAktualniKapacita(true));
                }
                return -1;
            }
        }
}
