﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DiplomovaPrace
{
    public partial class VrcholDialog : Form
    {
        private Vrchol vrchol;

        public Vrchol Vrchol
        {
            get { return vrchol; }
            set { vrchol = value; }
        }

        public VrcholDialog()
        {
            InitializeComponent();
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {

        }

        private void vrcholDialogLoad(object sender, EventArgs e)
        {
            nazevTextBox.Text = vrchol.Nazev;
            if (string.IsNullOrEmpty(vrchol.Klic.GetKlic()))
            {
                klicTextBox.Text = vrchol.Klic.GetKlic();
                ohodnoceniTextBox.Text = "0";
                minimalniCasTextBox.Text = "0";
            }
            else
            {
                klicTextBox.Text = vrchol.Klic.GetKlic();
                ohodnoceniTextBox.Text = vrchol.MaximalniCas.ToString();
                minimalniCasTextBox.Text = vrchol.MinimalniCas.ToString();
            }
        }

        private void VrcholDialog_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (DialogResult == DialogResult.Cancel) return;
            e.Cancel = true;
            #region chyby v zadávání údajů
            if (string.IsNullOrEmpty(klicTextBox.Text))
            {
                MessageBox.Show("Není vyplněn klíč vrcholu", "Chyba v zadávání", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (string.IsNullOrEmpty(nazevTextBox.Text))
            {
                MessageBox.Show("Není vyplněn název vrcholu", "Chyba v zadávání", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            double pomOhodnoceni;
            if (!double.TryParse(ohodnoceniTextBox.Text, out pomOhodnoceni))
            {
                MessageBox.Show("Není vyplněno korektně ohodnocení vrcholu", "Chyba v zadávání", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            #endregion
            e.Cancel = false;
        }

        private void VrcholDialog_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (DialogResult == DialogResult.Cancel) return;
            vrchol.Klic.SetKlic(klicTextBox.Text);
            vrchol.Nazev = nazevTextBox.Text;
            vrchol.MaximalniCas = double.Parse(ohodnoceniTextBox.Text);
        }
    }
}
