﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace DiplomovaPrace
{
    public class Zdroj
    {
        private String nazev;
        private double puvodniKapacita;
        private double aktualniKapacita;
        private bool obnovitelnost;
        private double cena;
        private double vyuziti;

        #region vlastnosti
        public double Vyuziti
        {
            get { return vyuziti; }
            set { vyuziti = value; }
        }
        public double Cena
        {
            get { return cena; }
            set { cena = value; }
        }
        public String Nazev
        {
            get { return nazev; }
            set { nazev = value; }
        }
        public double PuvodniKapacita
        {
            get { return puvodniKapacita; }
            set { puvodniKapacita = value; }
        }
        public double AktualniKapacita
        {
            get { return aktualniKapacita; }
            set { aktualniKapacita = value; }
        }
        public bool Obnovitelnost
        {
            get { return obnovitelnost; }
            set { obnovitelnost = value; }
        }
        #endregion

        public Zdroj()
        {
        }
        public Zdroj(String nazev, double puvodniKapacita, double aktualniKapacita, bool obnovitelnost)
        {
            this.nazev = nazev;
            this.aktualniKapacita = aktualniKapacita;
            this.puvodniKapacita = puvodniKapacita;
            this.obnovitelnost = obnovitelnost;
        }
        
        public override string ToString()
        {
            String obnovitelny;
            if (obnovitelnost == true) obnovitelny = "Obnovitelný";
            else obnovitelny = "Neobnovitelný";
            return ("Název: " + nazev + " Počáteční kapacita: " + puvodniKapacita.ToString() + " Aktuální kapacita: " + aktualniKapacita.ToString() + " " + obnovitelny);
        }
        /// <summary>
        /// Uloží zdroj do textového souboru.
        /// </summary>
        /// <param name="sw">Datový proud.</param>
        public void Uloz(StreamWriter sw)
        {
            sw.WriteLine(nazev);
            sw.WriteLine(puvodniKapacita);
            sw.WriteLine(aktualniKapacita);
            sw.WriteLine(obnovitelnost);
            sw.WriteLine(cena);
        }
        /// <summary>
        /// Načte zdroj z textového souboru.
        /// </summary>
        /// <param name="sr">Datový proud.</param>
        public void Nacti(StreamReader sr)
        {
            nazev = sr.ReadLine();
            string pomRet = sr.ReadLine();
            if (double.TryParse(pomRet, out puvodniKapacita) == false)
                throw new Exception("Chyba pří načítání ze souboru - není double");
            pomRet = sr.ReadLine();
            if (double.TryParse(pomRet, out aktualniKapacita) == false)
                throw new Exception("Chyba pří načítání ze souboru - není double");
            pomRet = sr.ReadLine();
            if (bool.TryParse(pomRet, out obnovitelnost) == false)
                throw new Exception("Chyba pří načítání ze souboru - není boolean");
            pomRet = sr.ReadLine();
            if (double.TryParse(pomRet, out cena) == false)
               throw new Exception("Chyba pří načítání ze souboru - není double");
        }
        /// <summary>
        /// Uloží zdroj do binárního souboru.
        /// </summary>
        /// <param name="bw">Datový proud.</param>
        public void Uloz(BinaryWriter bw)
        {
            bw.Write(nazev);
            bw.Write(puvodniKapacita);
            bw.Write(aktualniKapacita);
            bw.Write(obnovitelnost);
            bw.Write(cena);
        }
        /// <summary>
        /// Načte zdroj z binárního souboru.
        /// </summary>
        /// <param name="br">Datový proud.</param>
        public void Nacti(BinaryReader br)
        {
            nazev = br.ReadString();
            puvodniKapacita = br.ReadDouble();
            aktualniKapacita = br.ReadDouble();
            obnovitelnost = br.ReadBoolean();
            cena = br.ReadDouble();
        }

    }
}
