﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace DiplomovaPrace
{
    public class ZdrojHrany
    {
        private String nazev;
        private double spotreba;

        #region vlastnosti
        public String Nazev
        {
            get { return nazev; }
            set { nazev = value; }
        }
        public double Spotreba
        {
            get { return spotreba; }
            set { spotreba = value; }
        }
        #endregion

        public ZdrojHrany()
        {
        }
        public ZdrojHrany(String nazev, double spotreba)
        {
            this.nazev = nazev;
            this.spotreba = spotreba;
        }
        
        public override string ToString()
        {
             return ("Název: " + nazev + " Spotřeba: " + spotreba.ToString());
        }
        /// <summary>
        /// Uloží zdroj do textového souboru.
        /// </summary>
        /// <param name="sw">Datový proud.</param>
        public void Uloz(StreamWriter sw)
        {
            sw.WriteLine(nazev);
            sw.WriteLine(spotreba);
        }
        /// <summary>
        /// Načte zdroj z textového souboru.
        /// </summary>
        /// <param name="sr">Datový proud.</param>
        public void Nacti(StreamReader sr)
        {
            nazev = sr.ReadLine();
            string pomRet = sr.ReadLine();
            if (double.TryParse(pomRet, out spotreba) == false)
                throw new Exception("Chyba pří načítání ze souboru - není double");
        }
        /// <summary>
        /// Uloží zdroj do binárníhoho souboru.
        /// </summary>
        /// <param name="bw">Datový proud.</param>
        public void Uloz(BinaryWriter bw)
        {
            bw.Write(nazev);
            bw.Write(spotreba);
        }
        /// <summary>
        /// Načte zdroj z binárního souboru.
        /// </summary>
        /// <param name="br">Datový proud.</param>
        public void Nacti(BinaryReader br)
        {
            nazev = br.ReadString();
            spotreba = br.ReadDouble();
        }
    }
}
